<template>
  <!-- 新增编辑 -->
  <a-modal
    :width="524"
    :maskClosable="false"
    :visible="props.visible"
    :confirm-loading="loading"
    :forceRender="true"
    :title="isUpdate ? '编辑新闻分类' : '新建新闻分类'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
    @close="updateVisible(false)"
  >
    <a-form ref="formRef" :model="form" :rules="rules" layout="vertical">
      <a-form-item label="新闻分类名称:" name="categoryName">
        <a-input v-model:value="form.categoryName" allow-clear placeholder="请输入新闻分类名称" />
      </a-form-item>
      <a-form-item label="所属父级:" name="parentId">
        <a-tree-select
          v-model:value="form.parentId"
          style="width: 100%"
          showSearch
          :tree-data="typeList"
          treeNodeFilterProp="categoryName"
          :dropdown-style="{ maxHeight: '400px', overflow: 'auto' }"
          placeholder="请选择所属父级"
          :fieldNames="{ children: 'children', label: 'categoryName', key: 'categoryId', value: 'categoryId' }"
          allow-clear
          tree-default-expand-all
        />
      </a-form-item>
      <a-form-item label="分类排序:" name="fldSort">
        <a-input-number
          v-model:value="form.fldSort"
          :min="0"
          style="width: 100%"
          placeholder="请输入分类排序"
          allow-clear
          autocomplete="off"
        />
      </a-form-item>
    </a-form>
  </a-modal>
</template>

<script setup name="NewTypeAddEdit">
import { ref, onMounted, reactive } from 'vue';
import { message } from 'ant-design-vue';
import { NewTypeApi } from '../api/NewTypeApi';

const props = defineProps({
  visible: Boolean,
  data: Object,
  designId: String,
  categoryParentId: String,
});

const emits = defineEmits(['update:visible', 'done']);
// 弹框加载
const loading = ref(false);
// 是否是编辑状态
const isUpdate = ref(false);
// 表单数据
const form = ref({
  designId: props.designId,
  parentId: props.categoryParentId,
  fldSort: 100
});
// 验证规则
const rules = reactive({
  categoryName: [{ required: true, message: '请输入新闻分类名称', type: 'string', trigger: 'blur' }],
  parentId: [{ required: true, message: '请选择所属父级', type: 'string', trigger: 'blur' }],
  fldSort: [{ required: true, message: '请输入分类排序', type: 'number', trigger: 'blur' }]
});
// ref
const formRef = ref(null);

// 所属父级列表
const typeList = ref([]);

onMounted(async () => {
  if (props.data) {
    isUpdate.value = true;
    form.value = Object.assign({}, props.data);
  } else {
    isUpdate.value = false;
  }
  getTypeList();
});

const getTypeList = async () => {
  const res = await NewTypeApi.treeList({ designId: props.designId });
  typeList.value = [{ categoryId: '-1', categoryName: '根节点', children: res.data }];
};

// 更改弹框状态
const updateVisible = value => {
  emits('update:visible', value);
};

// 点击保存
const save = async () => {
  await formRef.value.validate();
  // 修改加载框为正在加载
  loading.value = true;

  let result = null;

  // 执行编辑或修改
  if (isUpdate.value) {
    result = NewTypeApi.edit(form.value);
  } else {
    result = NewTypeApi.add(form.value);
  }
  result
    .then(async result => {
      // 移除加载框
      loading.value = false;

      // 提示添加成功
      message.success(result.message);
      // 关闭弹框，通过控制visible的值，传递给父组件
      updateVisible(false);

      // 触发父组件done事件
      emits('done');
    })
    .catch(() => {
      loading.value = false;
    });
};
</script>

<style></style>
